"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide6.QtWidgets, except for defaults which are replaced by "...".
"""
from __future__ import annotations

from typing import overload

import PySide6.QtCore
import PySide6.QtGui
import PySide6.QtWidgets

class QCommonStyle(PySide6.QtWidgets.QStyle):
    """
    https://doc.qt.io/qt-6/qcommonstyle.html

    **Detailed Description**

    This abstract class implements some of the widget's look and feel that is
    common to all GUI styles provided and shipped as part of Qt.

    Since QCommonStyle inherits **QStyle** , all of its functions are fully
    documented in the **QStyle**  documentation.

    **See also** **QStyle**  and **QProxyStyle** .
    """

    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-6/qcommonstyle.html#QCommonStyle

        **QCommonStyle::QCommonStyle()**

        Constructs a QCommonStyle.
        """
        ...
    def drawComplexControl(
        self,
        cc: PySide6.QtWidgets.QStyle.ComplexControl,
        opt: PySide6.QtWidgets.QStyleOptionComplex,
        p: PySide6.QtGui.QPainter,
        w: PySide6.QtWidgets.QWidget | None = ...,
    ) -> None:
        """
        https://doc.qt.io/qt-6/qcommonstyle.html#drawComplexControl

        **[override virtual] void
        QCommonStyle::drawComplexControl(QStyle::ComplexControl cc , const
        QStyleOptionComplex * opt , QPainter * p , const QWidget * widget =
        nullptr) const**

        Reimplements: **QStyle::drawComplexControl(QStyle::ComplexControl
        control, const QStyleOptionComplex *option, QPainter *painter, const
        QWidget *widget) const** .
        """
        ...
    def drawControl(
        self,
        element: PySide6.QtWidgets.QStyle.ControlElement,
        opt: PySide6.QtWidgets.QStyleOption,
        p: PySide6.QtGui.QPainter,
        w: PySide6.QtWidgets.QWidget | None = ...,
    ) -> None:
        """
        https://doc.qt.io/qt-6/qcommonstyle.html#drawControl

        **[override virtual] void
        QCommonStyle::drawControl(QStyle::ControlElement element , const
        QStyleOption * opt , QPainter * p , const QWidget * widget = nullptr)
        const**

        Reimplements: **QStyle::drawControl(QStyle::ControlElement element,
        const QStyleOption *option, QPainter *painter, const QWidget *widget)
        const** .
        """
        ...
    def drawPrimitive(
        self,
        pe: PySide6.QtWidgets.QStyle.PrimitiveElement,
        opt: PySide6.QtWidgets.QStyleOption,
        p: PySide6.QtGui.QPainter,
        w: PySide6.QtWidgets.QWidget | None = ...,
    ) -> None:
        """
        https://doc.qt.io/qt-6/qcommonstyle.html#drawPrimitive

        **[override virtual] void
        QCommonStyle::drawPrimitive(QStyle::PrimitiveElement pe , const
        QStyleOption * opt , QPainter * p , const QWidget * widget = nullptr)
        const**

        Reimplements: **QStyle::drawPrimitive(QStyle::PrimitiveElement element,
        const QStyleOption *option, QPainter *painter, const QWidget *widget)
        const** .
        """
        ...
    def generatedIconPixmap(
        self,
        iconMode: PySide6.QtGui.QIcon.Mode,
        pixmap: PySide6.QtGui.QPixmap | PySide6.QtGui.QImage | str,
        opt: PySide6.QtWidgets.QStyleOption,
    ) -> PySide6.QtGui.QPixmap:
        """
        https://doc.qt.io/qt-6/qcommonstyle.html#generatedIconPixmap

        **[override virtual] QPixmap
        QCommonStyle::generatedIconPixmap(QIcon::Mode iconMode , const QPixmap &
        pixmap , const QStyleOption * opt ) const**

        Reimplements: **QStyle::generatedIconPixmap(QIcon::Mode iconMode, const
        QPixmap &pixmap, const QStyleOption *option) const** .
        """
        ...
    def hitTestComplexControl(
        self,
        cc: PySide6.QtWidgets.QStyle.ComplexControl,
        opt: PySide6.QtWidgets.QStyleOptionComplex,
        pt: PySide6.QtCore.QPoint,
        w: PySide6.QtWidgets.QWidget | None = ...,
    ) -> PySide6.QtWidgets.QStyle.SubControl:
        """
        https://doc.qt.io/qt-6/qcommonstyle.html#hitTestComplexControl

        **[override virtual] QStyle::SubControl
        QCommonStyle::hitTestComplexControl(QStyle::ComplexControl cc , const
        QStyleOptionComplex * opt , const QPoint & pt , const QWidget * widget =
        nullptr) const**

        Reimplements: **QStyle::hitTestComplexControl(QStyle::ComplexControl
        control, const QStyleOptionComplex *option, const QPoint &position,
        const QWidget *widget) const** .
        """
        ...
    def layoutSpacing(
        self,
        control1: PySide6.QtWidgets.QSizePolicy.ControlType,
        control2: PySide6.QtWidgets.QSizePolicy.ControlType,
        orientation: PySide6.QtCore.Qt.Orientation,
        option: PySide6.QtWidgets.QStyleOption | None = ...,
        widget: PySide6.QtWidgets.QWidget | None = ...,
    ) -> int:
        """
        https://doc.qt.io/qt-6/qcommonstyle.html#layoutSpacing

        **[override virtual] int
        QCommonStyle::layoutSpacing(QSizePolicy::ControlType control1 ,
        QSizePolicy::ControlType control2 , Qt::Orientation orientation , const
        QStyleOption * option = nullptr, const QWidget * widget = nullptr)
        const**

        Reimplements: **QStyle::layoutSpacing(QSizePolicy::ControlType control1,
        QSizePolicy::ControlType control2, Qt::Orientation orientation, const
        QStyleOption *option, const QWidget *widget) const** .
        """
        ...
    def pixelMetric(
        self,
        m: PySide6.QtWidgets.QStyle.PixelMetric,
        opt: PySide6.QtWidgets.QStyleOption | None = ...,
        widget: PySide6.QtWidgets.QWidget | None = ...,
    ) -> int:
        """
        https://doc.qt.io/qt-6/qcommonstyle.html#pixelMetric

        **[override virtual] int QCommonStyle::pixelMetric(QStyle::PixelMetric m
        , const QStyleOption * opt = nullptr, const QWidget * widget = nullptr)
        const**

        Reimplements: **QStyle::pixelMetric(QStyle::PixelMetric metric, const
        QStyleOption *option, const QWidget *widget) const** .
        """
        ...
    @overload
    def polish(self, app: PySide6.QtWidgets.QApplication) -> None:
        """
        https://doc.qt.io/qt-6/qcommonstyle.html#polish

        **[override virtual] void QCommonStyle::polish(QPalette & pal )**

        Reimplements: **QStyle::polish** (QPalette &palette).
        """
        ...
    @overload
    def polish(
        self,
        arg__1: (
            PySide6.QtGui.QPalette | PySide6.QtCore.Qt.GlobalColor | PySide6.QtGui.QColor
        ),
    ) -> None:
        """
        https://doc.qt.io/qt-6/qcommonstyle.html#polish-1

        **[override virtual] void QCommonStyle::polish(QApplication * app )**

        Reimplements: **QStyle::polish** (QApplication *application).
        """
        ...
    @overload
    def polish(
        self,
        palette: (
            PySide6.QtGui.QPalette | PySide6.QtCore.Qt.GlobalColor | PySide6.QtGui.QColor
        ),
    ) -> None:
        """
        https://doc.qt.io/qt-6/qcommonstyle.html#polish-2

        **[override virtual] void QCommonStyle::polish(QWidget * widget )**

        Reimplements: **QStyle::polish** (QWidget *widget).
        """
        ...
    @overload
    def polish(self, widget: PySide6.QtWidgets.QWidget) -> None:
        """
        https://doc.qt.io/qt-6/qcommonstyle.html#polish

        **[override virtual] void QCommonStyle::polish(QPalette & pal )**

        Reimplements: **QStyle::polish** (QPalette &palette).
        """
        ...
    def sizeFromContents(
        self,
        ct: PySide6.QtWidgets.QStyle.ContentsType,
        opt: PySide6.QtWidgets.QStyleOption,
        contentsSize: PySide6.QtCore.QSize,
        widget: PySide6.QtWidgets.QWidget | None = ...,
    ) -> PySide6.QtCore.QSize:
        """
        https://doc.qt.io/qt-6/qcommonstyle.html#sizeFromContents

        **[override virtual] QSize
        QCommonStyle::sizeFromContents(QStyle::ContentsType ct , const
        QStyleOption * opt , const QSize & csz , const QWidget * widget =
        nullptr) const**

        Reimplements: **QStyle::sizeFromContents(QStyle::ContentsType type,
        const QStyleOption *option, const QSize &contentsSize, const QWidget
        *widget) const** .
        """
        ...
    def standardIcon(
        self,
        standardIcon: PySide6.QtWidgets.QStyle.StandardPixmap,
        opt: PySide6.QtWidgets.QStyleOption | None = ...,
        widget: PySide6.QtWidgets.QWidget | None = ...,
    ) -> PySide6.QtGui.QIcon: ...
    def standardPixmap(
        self,
        sp: PySide6.QtWidgets.QStyle.StandardPixmap,
        opt: PySide6.QtWidgets.QStyleOption | None = ...,
        widget: PySide6.QtWidgets.QWidget | None = ...,
    ) -> PySide6.QtGui.QPixmap:
        """
        https://doc.qt.io/qt-6/qcommonstyle.html#standardPixmap

        **[override virtual] QPixmap
        QCommonStyle::standardPixmap(QStyle::StandardPixmap sp , const
        QStyleOption * option = nullptr, const QWidget * widget = nullptr)
        const**

        Reimplements: **QStyle::standardPixmap(QStyle::StandardPixmap
        standardPixmap, const QStyleOption *option, const QWidget *widget)
        const** .
        """
        ...
    def styleHint(
        self,
        sh: PySide6.QtWidgets.QStyle.StyleHint,
        opt: PySide6.QtWidgets.QStyleOption | None = ...,
        w: PySide6.QtWidgets.QWidget | None = ...,
        shret: PySide6.QtWidgets.QStyleHintReturn | None = ...,
    ) -> int:
        """
        https://doc.qt.io/qt-6/qcommonstyle.html#styleHint

        **[override virtual] int QCommonStyle::styleHint(QStyle::StyleHint sh ,
        const QStyleOption * opt = nullptr, const QWidget * widget = nullptr,
        QStyleHintReturn * hret = nullptr) const**

        Reimplements: **QStyle::styleHint(QStyle::StyleHint hint, const
        QStyleOption *option, const QWidget *widget, QStyleHintReturn
        *returnData) const** .
        """
        ...
    def subControlRect(
        self,
        cc: PySide6.QtWidgets.QStyle.ComplexControl,
        opt: PySide6.QtWidgets.QStyleOptionComplex,
        sc: PySide6.QtWidgets.QStyle.SubControl,
        w: PySide6.QtWidgets.QWidget | None = ...,
    ) -> PySide6.QtCore.QRect:
        """
        https://doc.qt.io/qt-6/qcommonstyle.html#subControlRect

        **[override virtual] QRect
        QCommonStyle::subControlRect(QStyle::ComplexControl cc , const
        QStyleOptionComplex * opt , QStyle::SubControl sc , const QWidget *
        widget = nullptr) const**

        Reimplements: **QStyle::subControlRect(QStyle::ComplexControl control,
        const QStyleOptionComplex *option, QStyle::SubControl subControl, const
        QWidget *widget) const** .
        """
        ...
    def subElementRect(
        self,
        r: PySide6.QtWidgets.QStyle.SubElement,
        opt: PySide6.QtWidgets.QStyleOption,
        widget: PySide6.QtWidgets.QWidget | None = ...,
    ) -> PySide6.QtCore.QRect:
        """
        https://doc.qt.io/qt-6/qcommonstyle.html#subElementRect

        **[override virtual] QRect
        QCommonStyle::subElementRect(QStyle::SubElement sr , const QStyleOption
        * opt , const QWidget * widget = nullptr) const**

        Reimplements: **QStyle::subElementRect(QStyle::SubElement element, const
        QStyleOption *option, const QWidget *widget) const** .
        """
        ...
    @overload
    def unpolish(self, application: PySide6.QtWidgets.QApplication) -> None:
        """
        https://doc.qt.io/qt-6/qcommonstyle.html#unpolish

        **[override virtual] void QCommonStyle::unpolish(QWidget * widget )**

        Reimplements: **QStyle::unpolish** (QWidget *widget).
        """
        ...
    @overload
    def unpolish(self, widget: PySide6.QtWidgets.QWidget) -> None:
        """
        https://doc.qt.io/qt-6/qcommonstyle.html#unpolish-1

        **[override virtual] void QCommonStyle::unpolish(QApplication *
        application )**

        Reimplements: **QStyle::unpolish** (QApplication *application).
        """
        ...
