"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide6.QtWidgets, except for defaults which are replaced by "...".
"""
from __future__ import annotations

from enum import IntFlag
from typing import overload

import PySide6.QtCore
import PySide6.QtGui
import PySide6.QtWidgets

class QStyleOptionGraphicsItem(PySide6.QtWidgets.QStyleOption):
    """
    https://doc.qt.io/qt-6/qstyleoptiongraphicsitem.html

    **Detailed Description**

    For performance reasons, there are few member functions and the access to
    the member variables is direct (i.e., using the `.` or `->` operator). This
    makes the structures straightforward to use and emphasizes that these are
    simply parameters used by the style functions.

    For an example demonstrating how style options can be used, see the
    **Styles**  example.

    **See also** **QStyleOption**  and **QGraphicsItem::paint** ().
    """

    Type: QStyleOptionGraphicsItem.StyleOptionType = ...
    Version: QStyleOptionGraphicsItem.StyleOptionVersion = ...

    class StyleOptionType(IntFlag):
        Type: QStyleOptionGraphicsItem.StyleOptionType = ...

    class StyleOptionVersion(IntFlag):
        Version: QStyleOptionGraphicsItem.StyleOptionVersion = ...
    @overload
    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-6/qstyleoptiongraphicsitem.html#QStyleOptionGraphic
        sItem

        **QStyleOptionGraphicsItem::QStyleOptionGraphicsItem()**

        Constructs a QStyleOptionGraphicsItem.
        """
        ...
    @overload
    def __init__(self, other: PySide6.QtWidgets.QStyleOptionGraphicsItem) -> None:
        """
        https://doc.qt.io/qt-6/qstyleoptiongraphicsitem.html#QStyleOptionGraphic
        sItem-1

        **QStyleOptionGraphicsItem::QStyleOptionGraphicsItem(const
        QStyleOptionGraphicsItem & other )**

        Constructs a copy of **other**.
        """
        ...
    @overload
    def __init__(self, version: int) -> None:
        """
        https://doc.qt.io/qt-6/qstyleoptiongraphicsitem.html#QStyleOptionGraphic
        sItem

        **QStyleOptionGraphicsItem::QStyleOptionGraphicsItem()**

        Constructs a QStyleOptionGraphicsItem.
        """
        ...
    @staticmethod
    def levelOfDetailFromTransform(worldTransform: PySide6.QtGui.QTransform) -> float:
        """
        https://doc.qt.io/qt-6/qstyleoptiongraphicsitem.html#levelOfDetailFromTr
        ansform

        **[static] qreal
        QStyleOptionGraphicsItem::levelOfDetailFromTransform(const QTransform &
        worldTransform )**

        Returns the level of detail from the **worldTransform**.

        Its value represents the maximum value of the height and width of a
        unity rectangle, mapped using the **worldTransform** of the painter used
        to draw the item. By default, if no transformations are applied, its
        value is 1. If zoomed out 1:2, the level of detail will be 0.5, and if
        zoomed in 2:1, its value is 2.

        **See also** **QGraphicsScene::minimumRenderSize** ().
        """
        ...
